<?php

class CascadingValidation {

    protected $ObjectNeededToRunThisThing;
    protected $Granularity = TRUE;
    protected $NonGranularMessage = NULL;
    protected $BypassPreRequisites = FALSE;
    protected $PreRequisiteValidationTypeArray = array();
    protected $MessageText;
    protected $RedirectURI;
    protected $RedirectLinkText;
    private   $Validationtype;

    public function SetWhateverObjectIsNeededToRunThisThing($Object) {
        $this->ObjectNeededToRunThisThing = $Object;
    }

    public function SetValidationType($ValidationType) {
        $this->ValidationType = $ValidationType;
    }

    public function SetGranularity ($Bool) {
        $this->Granularity = $Bool;
    }

    public function SetBypassPreRequisites($Bool) {
        $this->BypassPreRequisites = $Bool;
    }

    public function ValidateOrRedirect() {

        // This lets us turn validation on or off across the application
        if (VALIDATION_MODE_CONSTANT === 'OFF') {
            return TRUE;
        }

        $Class = $this->TypeOfValidation . 'ValidateOrRedirect';
        $Strategy = new $Class();

        // We can also cascade the attributes of the validation objects
        if ($this->Granularity === FALSE) {
            $Strategy->SetGranularity(FALSE);
        }

        if ($this->BypassPreRequisites !== TRUE) {
            $Strategy->RunPreRequisiteValidation($this->ObjectNeededToRunThisThing);
        }

        $Strategy->PerformValidateOrRedirect($this->ObjectNeededToRunThisThing);
    }

    protected function RunPreRequisiteValidation ($ObjectNeededToRunThisThing) {

        if (count($this->PreRequisiteValidationTypeArray) === 0) {
            return TRUE;
        } else {
            foreach ($this->PreRequisiteValidationTypeArray as $TypeOfValidation) {
                $Validation = new CascadingValidation;
                $Validation->SetObjectNeededToRunThisThing($ObjectNeededToRunThisThing);
                $Validation->SetValidationType($TypeOfValidation);

                // More cascading
                if ($this->Granularity === FALSE) {
                    $Validation->SetGranularity(FALSE);
                }

                $Validation->ValidateOrRedirect();
            }
        }
    }

    protected function DoRedirect ($Message, $RedirectURI, $RedirectLinkText = NULL) {

        if ($this->Granularity === FALSE) {

            $FlashMessage = new FlashMessage();

            if ($this->NonGranularMessage === NULL) {
                $FlashMessage->SetMessage("Can not proceed because the following has not been completed: " . str_replace("ValidateOrRedirect", "", get_class($this)));
            } else {
                $FlashMessage->SetMessage($this->NonGranularMessage);
            }

            $FlashMessage->SetRedirect('/WhereWeShouldBe/', 'Continue');
            $FlashMessage->Go();

        } else {

            $FlashMessage = new FlashMessage();
            $FlashMessage->SetMessage($Message);

            if ($RedirectLinkText) {
                $FlashMessage->SetRedirect($RedirectURI, $RedirectLinkText);
            } else {
                $FlashMessage->SetRedirect($RedirectURI);
            }

            $FlashMessage->Go();
        }
    }
}
