<?php

class PickSeatValidateOrRedirect extends CascadingValidation implements ValidateOrRedirectStrategy {

    protected $PreRequisiteValidationTypeArray = array(
        'ConfirmedTravelDate',
        'PaidForTickets'
    );

    protected $NonGranularMessage = "You cannot yet reserve this seat online; call customer service.";

    public function PerformValidateOrRedirect($ObjectNeededToRunThisThing) {

        /* The beauty here is that if an object is
        used as a prerequisite of another object's
        validation, all you need to do is disable
        it and the next step will fail. */
        if (!$ObjectNeededToRunThisThing->DesiredSeat->IsAvailable()) {
            $this->DoRedirect (
               'Sorry, this seat is not available', // Message
               '/PickYourSeat/Again',     // Redirect to...
               'Please Pick Another Seat' // Link text
            );
        }
    }
}

?>
