<?php
/**
 * Generate watermarked and thumbnail copies of an image
 * @param string source
 * @param string watermark
 * @return void
 */
function watermarkImage($src, $watermark)
{
    $output = array(
        'marked' => 'marked.'.$src,
        'thumb'  => 'thumb.'. $src,
    );

    $image = new Imagick($src);
    $thumb = $image->clone();

    $thumb->cropThumbnailImage(96, 128);
    $thumb->writeImage($output['thumb']);

    $mark = new Imagick($watermark);
    $mark->setImageColorspace(Imagick::COLORSPACE_GRAY);
    $mark->negateImage(true);
    /* recently-added method, may not work for you */
    $mark->setImageOpacity(0.7);

    $image->compositeImage($mark, Imagick::COMPOSITE_PLUS,
       $image->getImageWidth() - $mark->getImageWidth(),
       $image->getImageHeight() - $mark->getImageHeight()
    );

    $image->writeImage($output['marked']);

    return;
}

waterMarkImage('seashore.jpg', 'oopsilon-logo.png');

?>
