<?php
// Generate a graph based on CSV financial data

// Image size and margin
$dim    = array('x' => 1600, 'y' => 1200);
$margin = 100;

// Read in the CSV
$x = array();
$y = array();

$fp = fopen('ftse.csv', 'r');

for ($i = 0; $row = fgetcsv($fp); $i++) {
    $x[$i] = strtotime($row[0]);
    $y[$i] = $row[4];
}

$min = min($y);
$max = max($y);

// Work out graph size
$size = array(
    'x' => $dim['x'] - $margin * 2,
    'y' => $dim['y'] - $margin * 2,
);

// Calculate the width of a step on each axis
$step = array(
    'x' => $size['x'] / (count($y) - 1),
    'y' => $size['y'] / ($max - $min),
);

// Calculate pixel positions for graph plot
// Note: Y-values are reversed; origin is at top-left
$pixels = array();

foreach ($y as $k => $v) {
    $pixels[$k] = array(
        'x' => (int)($k * $step['x']) + $margin,
        'y' => $size['y'] - (int)(($v - $min) * $step['y']) + $margin,
    );
}

// Set colours
$black = new ImagickPixel('black');
$white = new ImagickPixel('white');

// Make a blank image
$image = new Imagick();
$image->newImage($dim['x'], $dim['y'], $white);

// Draw the plot
$draw = new ImagickDraw();
$draw->setStrokeColor($black);
$draw->setFillColor($white);
$draw->polyline($pixels);

// Apply draw commands to image, and output
$image->drawImage($draw);
$image->setImageFormat('png');
$image->writeImage('ftse-graph.png');

?>
