<?php

$imgdim = array('x' => 1600, 'y' => 400);
$len = 8;

$celldim = array('x' => $imgdim['x'] / $len,
                 'y' => $imgdim['y'],
);

// Build a random string of $len characters
$chars = 'ABCDEFGHJKLMNPQRSTUVWXYZ3456789abcdefghjkmpqrtuy';
$str = '';

for ($i = 0; $i < $len; $i++) {
    $str .= $chars[rand(0, strlen($chars) - 1)];
}

// Save in the session for later checking
session_start();
$_SESSION['captcha'] = $str;

// Set up a blank image and font parameters
$image = new Imagick();
$image->newImage($imgdim['x'], $imgdim['y'],
              new ImagickPixel('white'));

$draw = new ImagickDraw();
$draw->setFontFamily('Vera');
$draw->setFontSize(200);
$draw->setGravity(Imagick::GRAVITY_NORTHWEST);
$draw->setStrokeColor(new ImagickPixel('black'));
$draw->setStrokeWidth(2);

for ($i = 0; $i < $len; $i++) {
    // Set a random shade of gray as the fill color
    // using rgb() syntax for ImagickPixel
    $col = rand(0, 255);
    $draw->setFillColor(new ImagickPixel(
            sprintf('rgb(%d,%d,%d)', $col, $col, $col)
        )
    );

    // Find out how large this letter will be
    $chardim = $image->queryFontMetrics($draw, $str[$i], false);

    // Place in a random position within the cell
    $draw->annotation(
        $i * $celldim['x'] +
        rand(0, $celldim['x'] - $chardim['textWidth']),
        rand(0, $celldim['y'] - $chardim['textHeight']),
        $str[$i]
    );
}

// Render and output result
$image->drawImage($draw);
$image->setImageFormat('gif');
header('Content-type: image/gif');
echo $image;

?>
