<?php

import namespace SaltCityTech:::DbQuery;
import namespace MySql:::Data:::MySqlClient;
import namespace System;
import namespace System:::Data;
import namespace System:::Drawing;
import namespace System:::Windows:::Forms;

namespace SaltCityTech:::DbQuery
{
    class DbQueryApp extends Form
    {
        private $mnuMain;
        private $mnuFile;
        private $mnuFileExit;
        private $lblQuery;
        private $txtQueryString;
        private $btnSubmit;
        private $dgvResult;

        public static function Main()
        {
            Application::EnableVisualStyles();
            Application::SetCompatibleTextRenderingDefault(false);
            Application::Run(new DbQueryApp());
        }

        public function __construct()
        {
            // populate the form controls
            $this->mnuMain = new MenuStrip();
            $this->mnuFile = new ToolStripMenuItem();
            $this->mnuFileExit = new ToolStripMenuItem();
            $this->lblQuery = new Label();
            $this->txtQueryString = new TextBox();
            $this->btnSubmit = new Button();
            $this->dgvResult = new DataGridView();

            // prepare for menu layout
            $this->mnuMain->SuspendLayout();
            $this->dgvResult->BeginInit();

            $this->mnuMain->Items->Add($this->mnuFile);
            $this->mnuMain->Location = new Point(0, 0);
            $this->mnuMain->Size = new Size(517, 24);
            $this->mnuMain->TabIndex = 0;

            $this->mnuFile->DropDownItems->Add($this->mnuFileExit);
            $this->mnuFile->Size = new Size(35, 20);
            $this->mnuFile->Text = '&File';

            $this->mnuFileExit->Size = new Size(35, 20);
            $this->mnuFileExit->Text = 'E&xit';
            $this->mnuFileExit->Click->Add(new EventHandler(array($this, 
                'ExitHandler')));

            // prepare for form layout
            $this->mnuMain->ResumeLayout(false);
            $this->mnuMain->PerformLayout();
            $this->SuspendLayout();

            // set the label's properties
            $this->lblQuery->Location = new Point(20, 45);
            $this->lblQuery->Size = new Size(35, 13);
            $this->lblQuery->Text = 'Query';

            // set the textbox's properties            
            $this->txtQueryString->Location = new Point(60, 42);
            $this->txtQueryString->Size = new Size(351, 20);
            $this->txtQueryString->TabIndex = 1;
           
            // set the button's properties
            $this->btnSubmit->Location = new Point(420, 40);
            $this->btnSubmit->Size = new Size(75, 23);
            $this->btnSubmit->Text = 'Submit';
            $this->btnSubmit->TabIndex = 2;
            $this->btnSubmit->Click->Add(new EventHandler(
                           array($this, 'SubmitHandler')));

            // set the datagrid's properties
            $this->dgvResult->Location = new Point(25, 80);
            $this->dgvResult->Size = new Size(470, 210);
            $this->dgvResult->TabIndex = 3;
            $this->dgvResult->ReadOnly = true;
            $this->dgvResult->RowHeadersVisible = false;
            $this->dgvResult->AllowUserToAddRows = false;
            $this->dgvResult->AllowUserToDeleteRows = false;
            $this->dgvResult->AllowUserToResizeRows = false;
            $this->dgvResult->ColumnHeadersHeightSizeMode = 
             DataGridViewColumnHeadersHeightSizeMode::AutoSize;
            $this->dgvResult->SelectionMode = 
             DataGridViewSelectionMode::FullRowSelect;

            // place the controls onto the form
            $this->ClientSize = new Size(517, 313);
            $this->Controls->Add($this->mnuMain);
            $this->Controls->Add($this->lblQuery);
            $this->Controls->Add($this->txtQueryString);
            $this->Controls->Add($this->btnSubmit);
            $this->Controls->Add($this->dgvResult);

            // set the form's properties
            $this->FormBorderStyle = FormBorderStyle::FixedSingle;
            $this->MainMenuStrip = $this->mnuMain;
            $this->MaximizeBox = false;
            $this->MinimizeBox = false;
            $this->StartPosition = FormStartPosition::CenterScreen;
            $this->Text = 'DB Query Viewer';
            $this->dgvResult->EndInit();

            // finish layout of form 
            $this->ResumeLayout(false);
            $this->PerformLayout();
        }

        public function ExitHandler($sender, $eventArgs)
        {
            // terminate the application
            Application::i'Exit'();
        }

        public function SubmitHandler($sender, $eventArgs)
        {
            // query the database and place the results in the data table
            $dataTable = $this->DBQuery($this->txtQueryString->Text);
            $this->dgvResult->DataSource = $dataTable;
        }

        private function DBConnect()
        {
            try
            {
                // connect to a MySQL database
                $conn = new MySqlConnection('server=192.168.1.101; ' .
                    'user id=TESTUSER; password=TESTPASS; database=TEST;');
                $conn->Open();
                return $conn;
            }
            catch (System:::Exception $e)
            {
                // Oops! connection failed - show an error
                MessageBox::Show('Could not establish '.
                    'a connection to the database.',
                    'Error', MessageBoxButtons::OK,
                    MessageBoxIcon::Error);
                return null;
            }
        }

        private function DBClose($conn)
        {
            // close the database connection
            $conn->Close();
            $conn = null;
        }
    
        private function DBQuery($queryString)
        {
            $conn = $this->DBConnect();
            if (!$conn)
            { 
                return null;
            }
            Try
            {
                // send the query to the database
                // populate a data table with the results
                $dataTable = new DataTable();
                $dataAdapter = new MySqlDataAdapter($queryString, $conn);
                $dataAdapter->Fill($dataTable);
                $this->DBClose($conn);
                return $dataTable;
            }
            catch (System:::Exception $e)
            {
                // Oops! show an error
                MessageBox::Show('Error in SQL query. '.
                    'Please correct and try again.',
                    'Error', MessageBoxButtons::OK,
                    MessageBoxIcon::Error);
                $this->DBClose($conn);
                return null;
            }
        }
    }
}

?>
